#include "StdAfx.h"
#include ".\xmltextshape.h"
#include "NByteArray.h"
#include "GDIPlusDC.h"
#include "ScriptletConstant.h"

#define INTER_LINE_GAP	0
#define MAX_VALUE		1024

static const TCHAR  ROOT[] = _T("root");
static const TCHAR  BR[] = _T("br");
static const TCHAR  EM[] = _T("em");
static const TCHAR  B[] = _T("b");


REGISTER_COMPONENT_CREATOR(SCRIPTLET_XMLTEXT_NODE, CXMLTextShape);
CXMLTextShape::CXMLTextShape(void)
{
	m_iWidth = 0;
	m_iHeight = 0;
	m_iBetweenEMSpace = 0;
	m_HighlightColor = RGB(0xFF, 0x0, 0x0);

	m_iMaxHeight = 0;
	m_iMaxWidth = 0;

	PARAFORMAT2 pf = this->GetParaFormat();
	//pf.wAlignment = PFA_CENTER;
	this->SetParaFormat(pf);	
}

CXMLTextShape::~CXMLTextShape(void)
{
}

HFONT CXMLTextShape::_CreateTextFont(HDC hDC)
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfWidth = 0;
	lf.lfOrientation = 0;
	lf.lfCharSet = m_cf.bCharSet;
	lf.lfOutPrecision = OUT_CHARACTER_PRECIS;
	lf.lfHeight = -MulDiv(m_cf.yHeight/20, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	lf.lfWeight = m_cf.dwEffects & CFE_BOLD ? FW_BOLD : FW_NORMAL;
	lf.lfItalic = m_cf.dwEffects & CFE_ITALIC ? TRUE : FALSE;
	_tcscpy(lf.lfFaceName, m_cf.szFaceName);

	HFONT hFont = ::CreateFontIndirect(&lf);
	return hFont;
}
void CXMLTextShape::DrawComponent(HDC hDC)
{
	USES_CONVERSION;

	CRect rcClient;
	GetDrawingBounds(&rcClient);
	CHARFORMAT2 cf = this->GetCharFormat();
	PARAFORMAT2 pf = this->GetParaFormat();
	int nVAlign = this->GetVAlign();

	if ( (cf.dwEffects & CFE_AUTOBACKCOLOR) == 0)
	{
		FillSolidRect(hDC, &rcClient, cf.crBackColor);
	}
	int nBkOld = SetBkMode(hDC, TRANSPARENT);
	COLORREF crOld = SetTextColor(hDC, cf.crTextColor);
	HFONT hFont = this->_CreateTextFont(hDC);
	HGDIOBJ hOldFont = SelectObject(hDC, hFont);

	UINT nFormat = 0;//DT_EDITCONTROL | DT_WORDBREAK;
	switch (nVAlign)
	{
	case PFA_TOP: nFormat |= DT_TOP; break;
	case PFA_VCENTER: nFormat |= DT_VCENTER; break;
	case PFA_BOTTOM: nFormat |= DT_BOTTOM; break;
	}
	switch (pf.wAlignment)
	{
	case PFA_LEFT: nFormat |= DT_LEFT; break;
	case PFA_CENTER: nFormat |= DT_CENTER; break;
	case PFA_RIGHT: nFormat |= DT_RIGHT; break;
	}
	

	//SIZE szText;
	int iX = 0;
	int iY = 5;
	
	TCHAR szValue[MAX_VALUE] = {0};
	TCHAR szValueForX[MAX_VALUE] = {0};

	TiXmlNode* pChildNode = GetFirstNode();
	TiXmlNode* pChildNodeForX = pChildNode;

	BOOL bNeedMeasure = TRUE;

	while( pChildNode )
	{
		ZeroMemory(szValue, MAX_VALUE);
		XMLUtil::GetChildValue(pChildNode, szValue, MAX_VALUE);

		//  ؼ...< br  ؼ  Ŀ ʿ ix >
        if( bNeedMeasure )
		{
			if( pf.wAlignment != PFA_LEFT )
			{
				CGDIPlusDC dcX;
				dcX.Attach(hDC);

				if( pChildNodeForX )
				{
					iX = 0;

					XMLUtil::GetChildValue(pChildNodeForX, szValueForX, MAX_VALUE);

					RectF rectOut;

					while( _tcscmp(szValueForX, BR) != 0 )
					{
						if( _tcscmp(szValueForX, EM) == 0 )
						{
							TiXmlNode* pChildElement = FirstChildElement(pChildNodeForX);
							XMLUtil::GetChildValue(pChildElement, szValueForX, MAX_VALUE);

							if ( _tcscmp(szValueForX, B) == 0 )
							{
								pChildElement = FirstChildElement(pChildElement);
								XMLUtil::GetChildValue(pChildElement, szValueForX, MAX_VALUE);
							}
						}

						dcX.MeasureString(szValueForX,cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, rectOut);
						iX += static_cast<LONG>(rectOut.Width);

						pChildNodeForX = GetNextNode(pChildNodeForX);
						if( !pChildNodeForX )
							break;
						XMLUtil::GetChildValue(pChildNodeForX, szValueForX, MAX_VALUE);
					}

					if( pChildNodeForX )
						pChildNodeForX = GetNextNode(pChildNodeForX);				

				} // if( !pChildNodeForX )
				dcX.Detach();
			}
			
			if(pf.wAlignment == PFA_LEFT)
				iX = 0;
			else if(pf.wAlignment == PFA_RIGHT)
				iX = m_iWidth - iX;
			else if(pf.wAlignment == PFA_CENTER)
				iX = (m_iWidth - iX)/2;			

			bNeedMeasure = FALSE;
		}

		if( _tcscmp(szValue, EM) == 0 )
		{
			TiXmlNode* pChildElement = FirstChildElement(pChildNode);		
			TiXmlElement* pBoldNode = pChildNode->FirstChildElement(T2A(B));
			if (pBoldNode)
			{
				cf.dwEffects |= CFE_BOLD;
				pChildElement = FirstChildElement(pBoldNode);
			}

			if( pChildElement )
			{
				XMLUtil::GetChildValue(pChildElement, szValue, MAX_VALUE);

				//::GetTextExtentPoint(hDC, (LPCSTR)ByteArray.GetBuffer(), strlen((char*)ByteArray.GetBuffer()), &szText);
				//rcClient = CRect(iX+m_iBetweenEMSpace, iY, iX + m_iBetweenEMSpace + szText.cx, iY + m_iMaxHeight);
				SetTextColor(hDC, m_HighlightColor);
				//DrawText(hDC, (LPCSTR)pBuf, -1, &rcClient, nFormat);
				CGDIPlusDC dc;
				dc.Attach(hDC);
				RectF rectOut;

				dc.MeasureString(szValue, cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, rectOut);
				rcClient.SetRect(iX+m_iBetweenEMSpace, iY, iX + m_iBetweenEMSpace + rectOut.Width + 1, iY + m_iMaxHeight);

				dc.DrawText(szValue, _tcslen(szValue), &rcClient, nFormat, cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, cf.dwEffects & CFE_UNDERLINE, m_HighlightColor);
				dc.Detach();
				SetTextColor(hDC, cf.crTextColor);

				iX += rectOut.Width;
			}			
		}
		else if( _tcscmp(szValue, BR) == 0 )
		{
			iX = 0;
			iY += (m_iMaxHeight + INTER_LINE_GAP);
			bNeedMeasure = TRUE;
		}
		else
		{
			//::GetTextExtentPoint(hDC, (LPCSTR)ByteArray.GetBuffer(), strlen((char*)ByteArray.GetBuffer()), &szText);
			//rcClient = CRect(iX, iY, iX + szText.cx, iY + m_iMaxHeight);

			//DrawText(hDC, (LPCSTR)pBuf, -1, &rcClient, nFormat);
			CGDIPlusDC dc;
			dc.Attach(hDC);
			RectF rectOut;
			dc.MeasureString(szValue,cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, rectOut);
			rcClient.SetRect(iX, iY, iX + rectOut.Width + 1, iY + m_iMaxHeight);
			dc.DrawText(szValue, _tcslen(szValue), &rcClient, nFormat, cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, cf.dwEffects & CFE_UNDERLINE, cf.crTextColor);
			dc.Detach();

			iX += rectOut.Width;
		}

		cf = this->GetCharFormat();
		pChildNode = GetNextNode(pChildNode);
	}

	SelectObject(hDC, hOldFont);
	SetTextColor(hDC, crOld);
	SetBkMode(hDC, nBkOld);

	DeleteObject(hFont);
}

void CXMLTextShape::SetText(LPCTSTR pszcText)
{		
	if( _tcslen(pszcText) == 0 )
		return;

	__super::SetText(pszcText);

	USES_CONVERSION;
	CString text;
	text.Append(_T("<?xml version=\"1.0\" encoding=\"utf-8\" ?> "));
	text.Append(_T("<root>"));
	text.Append(pszcText);
	text.Append(_T("</root>"));
	
	m_tiXmlDocument.Clear();
	char* buffer = XMLUtil::Encode_utf8(text);
	m_tiXmlDocument.Parse(buffer);
	delete []buffer;
	
	this->RecalcLayout();
	CalcWidthHeight();
}

BOOL CXMLTextShape::CalcWidthHeight()
{	
	HDC hDC = ::GetDC(NULL);
	if (hDC == NULL) return FALSE;

	HFONT hFont = this->_CreateTextFont(hDC);
	HGDIOBJ hOldFont = SelectObject(hDC, hFont);
	CHARFORMAT2 cf = __super::GetCharFormat();

	USES_CONVERSION;

	CGDIPlusDC dc;
	dc.Attach(hDC);
	
	m_iMaxWidth = 0;
	m_iMaxHeight = 0;

	TiXmlNode* pChildNode = GetFirstNode();

	TCHAR szValue[MAX_VALUE] = {0};
	int iLineCount = 0;
	int iTotalWidth = 0;
	int iEMCount = 0;
	while( pChildNode )
	{
		ZeroMemory(szValue, MAX_VALUE);
		XMLUtil::GetChildValue(pChildNode, szValue, MAX_VALUE);
		
        if( _tcscmp(szValue, BR) != 0 )
		{
			if( _tcscmp(szValue, EM) == 0 )
			{
				TiXmlNode* pChildElement = FirstChildElement(pChildNode);
				TiXmlElement* pBoldNode = pChildNode->FirstChildElement(T2A(B));
				if (pBoldNode)
				{
					cf.dwEffects |= CFE_BOLD;
					pChildElement = FirstChildElement(pBoldNode);
				}

				if( pChildElement )
				{
					XMLUtil::GetChildValue(pChildElement, szValue, MAX_VALUE);

					RectF rectOut;

					dc.MeasureString(_T(""),cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, rectOut);
					//m_iBetweenEMSpace = rectOut.Width;
					//iEMCount++;
				}				
			}

			RectF rectOut;

			dc.MeasureString(szValue, cf.szFaceName, cf.yHeight/20, cf.dwEffects & CFE_BOLD, cf.dwEffects & CFE_ITALIC, rectOut);

			iTotalWidth += rectOut.Width;
			
			if( m_iMaxHeight < rectOut.Height )
				m_iMaxHeight = rectOut.Height;
			if( m_iMaxWidth < iTotalWidth )
				m_iMaxWidth = iTotalWidth;

			pChildNode = GetNextNode(pChildNode);

			if( !pChildNode )
				iLineCount++;

			continue;
		}
		else
		{
			if( m_iMaxWidth < iTotalWidth )
				m_iMaxWidth = iTotalWidth;

			iTotalWidth = 0;
		}

		iLineCount++;
		
		cf = __super::GetCharFormat();
		pChildNode = GetNextNode(pChildNode);
	}

	m_iWidth = m_iMaxWidth + m_iBetweenEMSpace*iEMCount*2;
	m_iHeight = (m_iMaxHeight*iLineCount) + (INTER_LINE_GAP * iLineCount-1);    	

	dc.Detach();
	SelectObject(hDC, hOldFont);
	::ReleaseDC(NULL, hDC);

	DeleteObject(hFont);
	return TRUE;
}

void CXMLTextShape::SetHighlightFontColor(COLORREF clrFont)
{
	m_HighlightColor = clrFont;
}
COLORREF CXMLTextShape::GetHighlightFontColor()
{
	return m_HighlightColor;
}
BOOL CXMLTextShape::GetOrginPreferredSize(LPSIZE lpSize)
{
	lpSize->cx = m_iWidth;
	lpSize->cy = m_iHeight;
	return TRUE;
}
void CXMLTextShape::OnSize(INT32 nWidth, INT32 nHeight)
{
	__super::OnSize(nWidth, nHeight);

	this->CalcWidthHeight();
}
TiXmlNode* CXMLTextShape::GetFirstNode()
{
	USES_CONVERSION;

	TiXmlElement* pRoot = m_tiXmlDocument.FirstChildElement(T2A(ROOT));	
	if( !pRoot )
		return NULL;
	TiXmlNode* pChildNode = pRoot->FirstChild();

	if( !pChildNode )
		return NULL;

	return pChildNode;
}

TiXmlNode* CXMLTextShape::GetNextNode(TiXmlNode* pNode)
{
	TiXmlNode* pChildNode = pNode->NextSibling();

	if( !pChildNode )
		return NULL;

	return pChildNode;
}

TiXmlNode* CXMLTextShape::FirstChildElement(TiXmlNode* pNode)
{
	TiXmlNode* pChildElement = pNode->FirstChild();

	if( !pChildElement )
		return NULL;

	return pChildElement;
}